## rdma-core 44.0

=== debian/changelog ===
rdma-core (44.0-2) unstable; urgency=medium

  * debian: Add 32-bit MIPS architectures to COHERENT_DMA_ARCHS and
    inverse the list to NON_COHERENT_DMA_ARCHS (Closes: #1026088)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 10 Jan 2023 13:59:10 +0100

rdma-core (44.0-1) unstable; urgency=medium

  * New upstream release.
    - Add Microsoft Azure Network Adapter (MANA) RDMA provider
    - util: mmio: fix build on MIPS with binutils >= 2.35
  * Add 64-bit MIPS architectures to COHERENT_DMA_ARCHS (Closes: #1026088)
  * debian/watch: Query api.github.com for release tarballs

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 03 Jan 2023 17:29:32 +0100

=== debian/control ===
Source: rdma-core
Maintainer: Benjamin Drung <bdrung@ubuntu.com>
Section: net
Priority: optional
Build-Depends: cmake (>= 2.8.11),
               cython3,
               debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.17),
               libnl-3-dev,
               libnl-route-3-dev,
               libsystemd-dev,
               libudev-dev,
               ninja-build,
               pandoc,
               pkg-config,
               python3-dev,
               python3-docutils,
               valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x]
Rules-Requires-Root: no
Standards-Version: 4.6.1
Vcs-Git: https://github.com/linux-rdma/rdma-core.git -b debian/unstable
Vcs-Browser: https://github.com/linux-rdma/rdma-core
Homepage: https://github.com/linux-rdma/rdma-core

Package: rdma-core
Architecture: linux-any
Depends: lsb-base (>= 3.2-14~),
         udev,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: dmidecode, ethtool, iproute2
Breaks: infiniband-diags (<< 2.0.0)
Replaces: infiniband-diags (<< 2.0.0)
Description: RDMA core userspace infrastructure and documentation
 This package provides the basic boot time support for systems that use the
 Linux kernel's remote direct memory access (RDMA) subystem which includes
 InfiniBand, iWARP, and RDMA over Converged Ethernet (RoCE).
 .
 Several kernel RDMA support daemons are included:
  - The rdma-ndd daemon which watches for RDMA device changes and/or hostname
    changes and updates the Node Description of the RDMA devices based on
    those changes.
  - The iWARP Port Mapper Daemon (iwpmd) which provides a kernel support
    service in userspace for iWARP drivers to claim TCP ports through the
    standard socket interface.

Package: ibacm
Architecture: linux-any
Depends: lsb-base (>= 3.2-14~),
         rdma-core (>= 15),
         ${misc:Depends},
         ${shlibs:Depends}
Description: InfiniBand Communication Manager Assistant (ACM)
 The IB ACM implements and provides a framework for name, address, and
 route (path) resolution services over InfiniBand.
 It is intended to address connection setup scalability issues running
 MPI applications on large clusters.  The IB ACM provides information
 needed to establish a connection, but does not implement the CM protocol.
 A primary user of the ibacm service is the librdmacm library.

Package: ibverbs-providers
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libefa1, libipathverbs1, libmana1, libmlx4-1, libmlx5-1, libmthca1
Replaces: libipathverbs1 (<< 15),
          libmlx4-1 (<< 15),
          libmlx5-1 (<< 15),
          libmthca1 (<< 15)
Breaks: libipathverbs1 (<< 15),
        libmlx4-1 (<< 15),
        libmlx5-1 (<< 15),
        libmthca1 (<< 15)
Description: User space provider drivers for libibverbs
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 An RDMA driver consists of a kernel portion and a user space portion.
 This package contains the user space verbs drivers:
 .
  - bnxt_re: Broadcom NetXtreme-E RoCE HCAs
  - cxgb4: Chelsio T4 iWARP HCAs
  - efa: Amazon Elastic Fabric Adapter
  - erdma: Alibaba Elastic RDMA (iWarp) Adapter
  - hfi1verbs: Intel Omni-Path HFI
  - hns: HiSilicon Hip06 SoC
  - ipathverbs: QLogic InfiniPath HCAs
  - irdma: Intel Ethernet Connection RDMA
  - mana: Microsoft Azure Network Adapter
  - mlx4: Mellanox ConnectX-3 InfiniBand HCAs
  - mlx5: Mellanox Connect-IB/X-4+ InfiniBand HCAs
  - mthca: Mellanox InfiniBand HCAs
  - ocrdma: Emulex OneConnect RDMA/RoCE device
  - qedr: QLogic QL4xxx RoCE HCAs
  - rxe: A software implementation of the RoCE protocol
  - siw: A software implementation of the iWarp protocol
  - vmw_pvrdma: VMware paravirtual RDMA device

Package: ibverbs-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package contains useful libibverbs1 example programs such as
 ibv_devinfo, which displays information about InfiniBand devices.

Package: libibverbs-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ibverbs-providers (= ${binary:Version}),
         libibverbs1 (= ${binary:Version}),
         libnl-3-dev,
         libnl-route-3-dev,
         ${misc:Depends}
Description: Development files for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package is needed to compile programs against libibverbs1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibverbs1
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Recommends: ibverbs-providers
Breaks: ibverbs-providers (<< 34~)
Description: Library for direct userspace use of RDMA (InfiniBand/iWARP)
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 For this library to be useful, a device-specific plug-in module
 should also be installed.
 .
 This package contains the shared library.

Package: libibumad-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libibumad3 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libibumad
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package is needed to compile programs against libibumad.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibumad3
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Userspace Management Datagram (uMAD) library
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package contains the shared library.

Package: librdmacm-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libibverbs-dev, librdmacm1 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package is needed to compile programs against librdmacm1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: librdmacm1
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for managing RDMA connections
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains the shared library.

Package: rdmacm-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains useful librdmacm1 example programs such as
 rping and udaddy.

Package: srptools
Architecture: linux-any
Depends: lsb-base (>= 3.2-14~),
         rdma-core (>= 15),
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tools for Infiniband attached storage (SRP)
 In conjunction with the kernel ib_srp driver, srptools allows you to
 discover and use Infiniband attached storage devices which use the
 SCSI RDMA Protocol (SRP).

Package: python3-pyverbs
Section: python
Architecture: linux-any
Depends: rdma-core (>= 21),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python bindings for rdma-core
 Pyverbs provides a Python API over rdma-core, the Linux userspace C API for
 the remote direct memory access (RDMA) stack.
 .
 One goal is to provide easier access to RDMA: RDMA has a steep learning curve
 as is and the C interface requires the user to initialize multiple structs
 before having usable objects. Pyverbs attempts to remove much of this overhead
 and provide a smoother user experience.

Package: infiniband-diags
Architecture: linux-any
Depends: libibnetdisc5 (= ${binary:Version}),
         ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

NON_COHERENT_DMA_ARCHS = alpha arc armel armhf hppa m68k sh4

dh_params = --with python3 --builddirectory=build-deb

%:
	dh $@ $(dh_params)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build-deb
	for package in ibverbs-providers libibverbs-dev rdma-core; do \
		test ! -e debian/$$package.install.backup || mv debian/$$package.install.backup debian/$$package.install; \
	done

# Upstream wishes to use CMAKE_BUILD_TYPE=Release, and ensures that has a
# sensible basis of options (eg no -O3, including -g). Debian specific options
# come from CFLAGS as usual.
#
# Upstream encourages the use of Ninja to build the source, convince dh to use
# it until someone writes native support for dh+cmake+ninja.
DH_AUTO_CONFIGURE := "--" \
	             "-GNinja" \
		     "-DDISTRO_FLAVOUR=Debian" \
		     "-DCMAKE_BUILD_TYPE=Release" \
		     "-DCMAKE_INSTALL_SYSCONFDIR:PATH=/etc" \
		     "-DCMAKE_INSTALL_SYSTEMD_SERVICEDIR:PATH=/lib/systemd/system" \
		     "-DCMAKE_INSTALL_INITDDIR:PATH=/etc/init.d" \
		     "-DCMAKE_INSTALL_LIBEXECDIR:PATH=/usr/lib" \
		     "-DCMAKE_INSTALL_SHAREDSTATEDIR:PATH=/var/lib" \
		     "-DCMAKE_INSTALL_RUNDIR:PATH=/run" \
		     "-DCMAKE_INSTALL_UDEV_RULESDIR:PATH=/lib/udev/rules.d" \
		     "-DCMAKE_INSTALL_PERLDIR:PATH=/usr/share/perl5" \
		     "-DENABLE_STATIC=1" \
		     $(EXTRA_CMAKE_FLAGS)

override_dh_auto_configure:
	if [ -e /usr/bin/python3 ]; then \
		dh_auto_configure $(DH_AUTO_CONFIGURE) \
				-DPYTHON_EXECUTABLE:PATH=/usr/bin/python3 \
				-DCMAKE_INSTALL_PYTHON_ARCH_LIB:PATH=/usr/lib/python3/dist-packages; \
	else \
		dh_auto_configure $(DH_AUTO_CONFIGURE) \
			        -DNO_PYVERBS=1; \
	fi


override_dh_auto_build:
	ninja -C build-deb -v

# upstream does not ship test cases
override_dh_auto_test:

override_dh_auto_install:
# Some providers are disabled on architectures that are not able to do coherent DMA
ifeq (,$(filter-out $(NON_COHERENT_DMA_ARCHS),$(DEB_HOST_ARCH)))
	for package in ibverbs-providers libibverbs-dev rdma-core; do \
		test -e debian/$$package.install.backup || cp debian/$$package.install debian/$$package.install.backup; \
	done
	sed -i '/efa\|mana\|mlx[45]/d' debian/ibverbs-providers.install debian/libibverbs-dev.install debian/rdma-core.install
endif
	DESTDIR=$(CURDIR)/debian/tmp ninja -C build-deb install

# The following files are not used on Debian (we ship our own sysvinit script)
INST_EXCLUDE := "etc/init.d/srpd" \
		"etc/init.d/ibacm" \
		"usr/sbin/run_srp_daemon" \
		"usr/sbin/srp_daemon.sh"
INST_EXCLUDE := $(addprefix -X,$(INST_EXCLUDE))
override_dh_install:
	if [ -e build-deb/python/pyverbs/__init__.py ]; then \
		dh_install $(INST_EXCLUDE); \
	else \
		dh_install -Npython3-pyverbs $(INST_EXCLUDE) --remaining-packages; \
	fi

override_dh_missing:
	dh_missing --fail-missing $(INST_EXCLUDE)

# cmake installs the correct init scripts in the correct place, just setup the
# pre-postrms
override_dh_installinit:
	dh_installinit -prdma-core --onlyscripts --name=iwpmd
	dh_installinit --remaining-packages

override_dh_installsystemd:
	dh_installsystemd -pibacm --no-start ibacm.service
	dh_installsystemd -pibacm ibacm.socket
	dh_installsystemd --remaining-packages

# Provider plugin libaries are not shared libraries and do not belong in the
# shlibs file.
# librspreload is a LD_PRELOAD library and does not belong in the shlib files
SHLIBS_EXCLUDE = "/libibverbs/" "librspreload" "/ibacm/"
SHLIBS_EXCLUDE := $(addprefix --exclude=,$(SHLIBS_EXCLUDE))
override_dh_makeshlibs:
	dh_makeshlibs $(SHLIBS_EXCLUDE)

# Upstream encourages the use of 'build' as the developer build output
# directory, allow that directory to be present and still allow dh to work.
.PHONY: build
build:
	dh $@ $(dh_params)

=== debian/watch ===
version=4
opts="searchmode=plain" \
  https://api.github.com/repos/linux-rdma/rdma-core/releases?per_page=100 \
  https://github.com/linux-rdma/rdma-core/releases/download/v[^/]+/rdma-core-@ANY_VERSION@@ARCHIVE_EXT@

## rdma-core 47.0

=== CMakeLists.txt ===
# COPYRIGHT (c) 2016 Obsidian Research Corporation. See COPYING file
# Run cmake as:
#  mkdir build
#  cmake -GNinja ..
#  ninja
#
# Common options passed to cmake are:
#  -DIN_PLACE=1
#      Configure the build to be run from the build directory, this results in something
#      that is not installable.
#  -DCMAKE_EXPORT_COMPILE_COMMANDS=1
#      Write a compile_commands.json file for clang tooling
#  -DCMAKE_BUILD_TYPE=RelWithDebInfo
#      Change the optimization level, Debug disables optimization,
#      Release is for packagers
#  -DENABLE_VALGRIND=0 (default enabled)
#      Disable valgrind notations, this has a tiny positive performance impact
#  -DENABLE_RESOLVE_NEIGH=0 (default enabled)
#      Do not link to libnl and do not resolve neighbours internally for Ethernet,
#      and do not build iwpmd.
#  -DENABLE_STATIC=1 (default disabled)
#      Produce static libraries along with the usual shared libraries.
#  -DVERBS_PROVIDER_DIR='' (default /usr/lib.../libibverbs)
#      Use the historical search path for providers, in the standard system library.
#  -DNO_COMPAT_SYMS=1 (default disabled)
#      Do not generate backwards compatibility symbols in the shared
#      libraries. This may is necessary if using a dynmic linker that does
#      not support symbol versions, such as uclibc.
#  -DIOCTL_MODE=write (default both)
#      Disable new kABI ioctl() support and support only the legacy write
#      path. May also be 'ioctl' to disable fallback to write.
#  -DIBACM_SERVER_MODE_DEFAULT (default unix)
#      Selects how clients can connect to this server:
#      open) Allow incoming connections from any TCP client (internal or external).
#      loop) Limit incoming connections for server_port to 127.0.0.1.
#      unix) Use unix-domain sockets, hence limits service to the same machine.
#  -DIBACM_ACME_PLUS_KERNEL_ONLY_DEFAULT (default 0)
#      If non-zero, limit incoming requests to kernel or the ib_acme utility
#      (i.e. do not serve librdmacm requests)
#  -DPYTHON_EXECUTABLE
#      Override automatic detection of python to use a certain
#      exectuable. This can be used to force the build to use python2 on a
#      system that has python3 installed. Otherwise the build automatically
#      prefers python3 if available.
#   -DNO_PYVERBS=1 (default, build pyverbs)
#      Invoke cython to build pyverbs. Usually you will run with this option
#      set
#   -DENABLE_IBDIAGS_COMPAT=True (default False)
#      Include obsolete scripts. These scripts are replaced by C programs with
#      a different interface now.
#   -DNO_MAN_PAGES=1 (default 0, build/install the man pages)
#      Disable man pages. Allows rdma-core to be built and installed
#      (without man pages) when neither pandoc/rst2man nor the pandoc-prebuilt
#      directory are available.

if (${CMAKE_VERSION} VERSION_LESS "3.18.1")
	# Centos 7 support
	cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
else()
	cmake_minimum_required(VERSION 3.18.1 FATAL_ERROR)
endif()
project(rdma-core C)

# CMake likes to use -rdynamic too much, they fixed it in 3.4.
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
else()
  # .. but we really do want to opt out.
  string(REPLACE "-rdynamic" "" CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "${CMAKE_SHARED_LIBRARY_LINK_C_FLAGS}")
endif()

# Make RDMA_CHECK_C_LINKER_FLAG work better
if(POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif()

set(PACKAGE_NAME "RDMA")

# See Documentation/versioning.md
set(PACKAGE_VERSION "47.0")
# When this is changed the values in these files need changing too:
#   debian/control
#   debian/libibverbs1.symbols
set(IBVERBS_PABI_VERSION "34")
set(IBVERBS_PROVIDER_SUFFIX "-rdmav${IBVERBS_PABI_VERSION}.so")

#-------------------------
# Basic standard paths

# Override the CMAKE_INSTALL_ dirs to be under the build/ directory
if (IN_PLACE)
  set(CMAKE_INSTALL_SYSCONFDIR "${PROJECT_BINARY_DIR}/etc")
  set(CMAKE_INSTALL_BINDIR "${PROJECT_BINARY_DIR}/bin")
  set(CMAKE_INSTALL_SBINDIR "${PROJECT_BINARY_DIR}/bin")
  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}")
  set(CMAKE_INSTALL_LIBDIR "lib")
  set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

include(GNUInstallDirs)
# C include root
set(BUILD_INCLUDE ${PROJECT_BINARY_DIR}/include)
# Executables
set(BUILD_BIN ${PROJECT_BINARY_DIR}/bin)
# Libraries
set(BUILD_LIB ${PROJECT_BINARY_DIR}/lib)
# Static library pre-processing
set(BUILD_STATIC_LIB ${PROJECT_BINARY_DIR}/lib/statics)
# Used for IN_PLACE configuration
set(BUILD_ETC ${PROJECT_BINARY_DIR}/etc)
set(BUILD_PYTHON ${PROJECT_BINARY_DIR}/python)

set(IBDIAG_CONFIG_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/infiniband-diags")
set(IBDIAG_NODENAME_MAP_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/rdma/ib-node-name-map")

set(CMAKE_INSTALL_INITDDIR "${CMAKE_INSTALL_SYSCONFDIR}/init.d"
  CACHE PATH "Location for init.d files")
set(CMAKE_INSTALL_MODPROBEDIR "${CMAKE_INSTALL_SYSCONFDIR}/modprobe.d/"
  CACHE PATH "Location for modprobe.d files")
set(CMAKE_INSTALL_SYSTEMD_SERVICEDIR "${CMAKE_INSTALL_PREFIX}/lib/systemd/system"
  CACHE PATH "Location for systemd service files")
set(CMAKE_INSTALL_SYSTEMD_BINDIR "/lib/systemd"
  CACHE PATH "Location for systemd extra binaries")

set(ACM_PROVIDER_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/ibacm"
  CACHE PATH "Location for ibacm provider plugin shared library files.")
# Location to find the provider plugin shared library files
set(VERBS_PROVIDER_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/libibverbs"
  CACHE PATH "Location for provider plugin shared library files. If set to empty the system search path is used.")

# Allow the 'run' dir to be configurable, this historically has been /var/run, but
# some systems now use /run/
set(CMAKE_INSTALL_RUNDIR "var/run"
  CACHE PATH "Location for runtime information, typically /var/run, or /run")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_RUNDIR})
  set(CMAKE_INSTALL_FULL_RUNDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_RUNDIR}")
else()
  set(CMAKE_INSTALL_FULL_RUNDIR "${CMAKE_INSTALL_RUNDIR}")
endif()

# Allow the udev rules.d dir to be configurable, this has historically been
# /lib/udev/rules.d/, but some systems now prefix /usr/
set(CMAKE_INSTALL_UDEV_RULESDIR "lib/udev/rules.d"
  CACHE PATH "Location for system udev rules, typically /lib/udev/rules.d or /usr/lib/udev/rules.d")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_UDEV_RULESDIR})
  set(CMAKE_INSTALL_FULL_UDEV_RULESDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_UDEV_RULESDIR}")
else()
  set(CMAKE_INSTALL_FULL_UDEV_RULESDIR "${CMAKE_INSTALL_UDEV_RULESDIR}")
endif()

# Allow the perl library dir to be configurable
set(CMAKE_INSTALL_PERLDIR "share/perl5"
  CACHE PATH "Location for system perl library, typically /usr/share/perl5")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_PERLDIR})
  set(CMAKE_INSTALL_FULL_PERLDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_PERLDIR}")
else()
  set(CMAKE_INSTALL_FULL_PERLDIR "${CMAKE_INSTALL_PERLDIR}")
endif()

# Location to place provider .driver files
if (IN_PLACE)
  set(CONFIG_DIR "${BUILD_ETC}/libibverbs.d")
  set(VERBS_PROVIDER_DIR "${BUILD_LIB}")
  set(ACM_PROVIDER_DIR "${BUILD_LIB}/ibacm")
else()
  set(CONFIG_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/libibverbs.d")
endif()

set(DISTRO_FLAVOUR "None" CACHE
  STRING "Flavour of distribution to install for. This primarily impacts the init.d scripts installed.")

#-------------------------
# Load CMake components
set(BUILDLIB "${PROJECT_SOURCE_DIR}/buildlib")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${BUILDLIB}")

include(CMakeParseArguments)
include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckIncludeFile)
include(CheckTypeSize)
include(RDMA_EnableCStd)
include(RDMA_Sparse)
include(RDMA_BuildType)
include(RDMA_DoFixup)
include(publish_headers)
include(rdma_functions)
include(pyverbs_functions)
if (NO_MAN_PAGES)
  # define empty stub functions to omit man page processing
  function(rdma_man_pages)
  endfunction()
  function(rdma_alias_man_pages)
  endfunction()
else()
  include(rdma_man)
endif()

if (NOT DEFINED ENABLE_STATIC)
  set(ENABLE_STATIC "OFF" CACHE BOOL "Produce static linking libraries as well as shared libraries.")
endif()

#-------------------------
# Setup the basic C compiler
RDMA_BuildType()
include_directories(${BUILD_INCLUDE})

# Working means that the compiler doesn't spew output that confuses cmake's
# capabilitiy tests. ie cmake will test and succeed a simple program
RDMA_Check_C_Compiles(HAVE_WORKING_WERROR "int main(int argc,const char *argv[]) { return 0; }" "")
if (NOT HAVE_WORKING_WERROR)
  message(FATAL_ERROR "-Werror doesn't work (compiler always creates warnings?). Werror is required for CMake.")
endif()

# Look for Python. We prefer some variant of python 3 if the system has it.
FIND_PACKAGE(PythonInterp 3 QUIET)
if (PythonInterp_FOUND)
  # pyverbs can only use python3:
  if (NO_PYVERBS)
    set(CYTHON_EXECUTABLE "")
  else()
    FIND_PACKAGE(cython)
  endif()
else()
  # But we still must have python (be it 2) for the build process:
  FIND_PACKAGE(PythonInterp REQUIRED)
  set(CYTHON_EXECUTABLE "")
endif()

find_program(SYSTEMCTL_BIN systemctl HINTS "/usr/bin" "/bin")
if (NOT SYSTEMCTL_BIN)
  set (SYSTEMCTL_BIN "/bin/systemctl")
endif()

RDMA_CheckSparse()

# Require GNU99 mode
RDMA_EnableCStd()

# Extra warnings. Turn on -Wextra to keep aware of interesting developments from gcc,
# but turn off some that are not terribly useful for this source.
# FIXME: I wonder how many of the signed compares are bugs?
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WARNINGS
  "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_PROTOTYPES "-Wmissing-prototypes")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_DECLARATIONS "-Wmissing-declarations")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WWRITE_STRINGS "-Wwrite-strings")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WFORMAT_2 "-Wformat=2")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WCAST_FUNCTION "-Wcast-function-type")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WFORMAT_NONLITERAL "-Wformat-nonliteral")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WDATE_TIME "-Wdate-time")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNESTED_EXTERNS "-Wnested-externs")

# At some point after 4.4 gcc fixed shadow to ignore function vs variable
# conflicts
RDMA_Check_C_Compiles(HAVE_C_WORKING_SHADOW "
 #include <unistd.h>
 int main(int argc,const char *argv[]) { int access = 1; return access; }"
  "-Wshadow")
if (HAVE_C_WORKING_SHADOW)
  RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WORKING_SHADOW "-Wshadow")
endif()

# At some point around 5.4 gcc fixed missing-field-initializers to ignore this
# common idiom we use extensively. Since this is a useful warning for
# developers try and leave it on if the compiler supports it.
RDMA_Check_C_Compiles(HAVE_C_WORKING_MISSING_FIELD_INITIALIZERS "
 struct foo { int a; int b; };
 int main(int argc,const char *argv[]) { struct foo tmp = {}; return tmp.a; }"
)
if (NOT HAVE_C_WORKING_MISSING_FIELD_INITIALIZERS)
  RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNO_MISSING_FIELD_INITIALIZERS "-Wno-missing-field-initializers")
endif()

# clang doesn't support variable size GCC extension
RDMA_Check_C_Compiles(HAVE_C_VARIABLE_SIZE "
 struct c { int a; int b[]; };
 struct foo { struct c c; int b; };
 int main(int argc,const char *argv[]) { return 0; }"
)
if (NOT HAVE_C_VARIABLE_SIZE)
	RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNO_VARIABLE_SIZE "-Wno-gnu-variable-sized-type-not-at-end")
endif()

# Check that the compiler supports -fno-strict-aliasing.
# The use of this flag in the source is discouraged
set(NO_STRICT_ALIASING_FLAGS "")
RDMA_AddOptCFlag(NO_STRICT_ALIASING_FLAGS HAVE_NO_STRICT_ALIASING
  "-fno-strict-aliasing")

# pyverbs has a problem with var-tracking warnings, turn it off if we can.
set(NO_VAR_TRACKING_FLAGS "")
RDMA_AddOptCFlag(NO_VAR_TRACKING_FLAGS HAVE_NO_VAR_TRACKING_ASSIGNMENTS
  "-fno-var-tracking-assignments")

RDMA_Check_C_Compiles(HAVE_FUNC_ATTRIBUTE_IFUNC "
 #include <unistd.h>

 void entry(void);

 static void do_entry(void) {}
 void entry(void) __attribute__((ifunc(\"resolve_entry\")));

=== debian/changelog ===
rdma-core (47.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop obsolete versioned dependency on lsb-base

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 07 Aug 2023 11:26:40 +0200

=== debian/control ===
--- 
+++ 
@@ -25,11 +25,7 @@
 
 Package: rdma-core
 Architecture: linux-any
-Depends: lsb-base (>= 3.2-14~),
-         udev,
-         ${misc:Depends},
-         ${perl:Depends},
-         ${shlibs:Depends}
+Depends: udev, ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Recommends: dmidecode, ethtool, iproute2
 Breaks: infiniband-diags (<< 2.0.0)
@@ -49,10 +45,7 @@
 
 Package: ibacm
 Architecture: linux-any
-Depends: lsb-base (>= 3.2-14~),
-         rdma-core (>= 15),
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: rdma-core (>= 15), ${misc:Depends}, ${shlibs:Depends}
 Description: InfiniBand Communication Manager Assistant (ACM)
  The IB ACM implements and provides a framework for name, address, and
  route (path) resolution services over InfiniBand.
@@ -261,11 +254,7 @@
 
 Package: srptools
 Architecture: linux-any
-Depends: lsb-base (>= 3.2-14~),
-         rdma-core (>= 15),
-         udev,
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: rdma-core (>= 15), udev, ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Tools for Infiniband attached storage (SRP)
  In conjunction with the kernel ib_srp driver, srptools allows you to
@@ -293,3 +282,7 @@
 Architecture: linux-any
 Depends: libibnetdisc5 (= ${binary:Version}),
          ${misc:Depends},
+         ${perl:Depends},
+         ${shlibs:Depends}
+Description: InfiniBand diagnostic programs
+ InfiniBand is a switched fabric communications link used in

## rdma-core 48.0

=== debian/changelog ===
rdma-core (48.0-1) unstable; urgency=medium

  * New upstream release.

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 23 Oct 2023 18:40:29 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                python3-docutils,
                valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x]
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://github.com/linux-rdma/rdma-core.git -b debian/unstable
 Vcs-Browser: https://github.com/linux-rdma/rdma-core
 Homepage: https://github.com/linux-rdma/rdma-core

## rdma-core 50.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,6 +52,8 @@
 #      Disable man pages. Allows rdma-core to be built and installed
 #      (without man pages) when neither pandoc/rst2man nor the pandoc-prebuilt
 #      directory are available.
+#   -DENABLE_LTTNG (default, no tracing support)
+#      Enable LTTng tracing.
 
 if (${CMAKE_VERSION} VERSION_LESS "3.18.1")
 	# Centos 7 support
@@ -77,7 +79,7 @@
 set(PACKAGE_NAME "RDMA")
 
 # See Documentation/versioning.md
-set(PACKAGE_VERSION "47.0")
+set(PACKAGE_VERSION "50.0")
 # When this is changed the values in these files need changing too:
 #   debian/control
 #   debian/libibverbs1.symbols
@@ -212,19 +214,27 @@
   message(FATAL_ERROR "-Werror doesn't work (compiler always creates warnings?). Werror is required for CMake.")
 endif()
 
-# Look for Python. We prefer some variant of python 3 if the system has it.
-FIND_PACKAGE(PythonInterp 3 QUIET)
-if (PythonInterp_FOUND)
-  # pyverbs can only use python3:
-  if (NO_PYVERBS)
-    set(CYTHON_EXECUTABLE "")
+# Use Python modules based on CMake version for backward compatibility
+set(CYTHON_EXECUTABLE "")
+if (${CMAKE_VERSION} VERSION_LESS "3.12")
+  # Look for Python. We prefer some variant of python 3 if the system has it
+  FIND_PACKAGE(PythonInterp 3 QUIET)
+  if (PythonInterp_FOUND)
+    # pyverbs can only use python3:
+    if (NOT NO_PYVERBS)
+      FIND_PACKAGE(cython)
+    endif()
   else()
+    # But we still must have python (be it 2) for the build process
+    FIND_PACKAGE(PythonInterp REQUIRED)
+  endif()
+else()
+  # FindPython looks preferably for Python3. If not found, version 2 is searched
+  FIND_PACKAGE(Python COMPONENTS Interpreter REQUIRED)
+  set(PYTHON_EXECUTABLE ${Python_EXECUTABLE})
+  if (NOT NO_PYVERBS AND Python_VERSION_MAJOR EQUAL 3)
     FIND_PACKAGE(cython)
   endif()
-else()
-  # But we still must have python (be it 2) for the build process:
-  FIND_PACKAGE(PythonInterp REQUIRED)
-  set(CYTHON_EXECUTABLE "")
 endif()
 
 find_program(SYSTEMCTL_BIN systemctl HINTS "/usr/bin" "/bin")
@@ -285,18 +295,3 @@
 # Check that the compiler supports -fno-strict-aliasing.
 # The use of this flag in the source is discouraged
 set(NO_STRICT_ALIASING_FLAGS "")
-RDMA_AddOptCFlag(NO_STRICT_ALIASING_FLAGS HAVE_NO_STRICT_ALIASING
-  "-fno-strict-aliasing")
-
-# pyverbs has a problem with var-tracking warnings, turn it off if we can.
-set(NO_VAR_TRACKING_FLAGS "")
-RDMA_AddOptCFlag(NO_VAR_TRACKING_FLAGS HAVE_NO_VAR_TRACKING_ASSIGNMENTS
-  "-fno-var-tracking-assignments")
-
-RDMA_Check_C_Compiles(HAVE_FUNC_ATTRIBUTE_IFUNC "
- #include <unistd.h>
-
- void entry(void);
-
- static void do_entry(void) {}
- void entry(void) __attribute__((ifunc(\"resolve_entry\")));

=== tests/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file

rdma_python_test(tests
  __init__.py
  args_parser.py
  base.py
  base_rdmacm.py
  cuda_utils.py
  efa_base.py
  irdma_base.py
  mlx5_base.py
  mlx5_prm_structs.py
  rdmacm_utils.py
  test_addr.py
  test_atomic.py
  test_cq.py
  test_cq_events.py
  test_cqex.py
  test_cuda_dmabuf.py
  test_device.py
  test_efa_srd.py
  test_efadv.py
  test_flow.py
  test_fork.py
  test_mlx5_cq.py
  test_mlx5_crypto.py
  test_mlx5_cuda_umem.py
  test_mlx5_dc.py
  test_mlx5_devx.py
  test_mlx5_dm_ops.py
  test_mlx5_dma_memcpy.py
  test_mlx5_dr.py
  test_mlx5_flow.py
  test_mlx5_huge_page.py
  test_mlx5_lag_affinity.py
  test_mlx5_mkey.py
  test_mlx5_pp.py
  test_mlx5_query_port.py
  test_mlx5_raw_wqe.py
  test_mlx5_rdmacm.py
  test_mlx5_sched.py
  test_mlx5_timestamp.py
  test_mlx5_uar.py
  test_mlx5_udp_sport.py
  test_mlx5_var.py
  test_mlx5_vfio.py
  test_mr.py
  test_odp.py
  test_pd.py
  test_parent_domain.py
  test_qp.py
  test_qpex.py
  test_rdmacm.py
  test_relaxed_ordering.py
  test_rss_traffic.py
  test_shared_pd.py
  test_srq.py
  test_tag_matching.py
  utils.py
  )

rdma_python_test(tests
  run_tests.py
  )

rdma_internal_binary(
  run_tests.py
  )

=== providers/mana/man/CMakeLists.txt ===
rdma_man_pages(
  manadv.7.md
  manadv_init_obj.3.md
  manadv_set_context_attr.3.md
)

=== providers/mlx4/man/CMakeLists.txt ===
rdma_man_pages(
  mlx4dv_init_obj.3
  mlx4dv_query_device.3
  mlx4dv_set_context_attr.3.md
  mlx4dv.7
)

=== providers/mlx5/man/CMakeLists.txt ===
rdma_man_pages(
  mlx5dv_alloc_dm.3.md
  mlx5dv_alloc_var.3.md
  mlx5dv_create_cq.3.md
  mlx5dv_create_flow.3.md
  mlx5dv_create_flow_action_modify_header.3.md
  mlx5dv_create_flow_action_packet_reformat.3.md
  mlx5dv_create_flow_matcher.3.md
  mlx5dv_create_mkey.3.md
  mlx5dv_create_qp.3.md
  mlx5dv_create_steering_anchor.3.md
  mlx5dv_crypto_login.3.md
  mlx5dv_crypto_login_create.3.md
  mlx5dv_dci_stream_id_reset.3.md
  mlx5dv_dek_create.3.md
  mlx5dv_devx_alloc_msi_vector.3.md
  mlx5dv_devx_alloc_uar.3.md
  mlx5dv_devx_create_cmd_comp.3.md
  mlx5dv_devx_create_eq.3.md
  mlx5dv_devx_create_event_channel.3.md
  mlx5dv_devx_get_event.3.md
  mlx5dv_devx_obj_create.3.md
  mlx5dv_devx_qp_modify.3.md
  mlx5dv_devx_query_eqn.3.md
  mlx5dv_devx_subscribe_devx_event.3.md
  mlx5dv_devx_umem_reg.3.md
  mlx5dv_dm_map_op_addr.3.md
  mlx5dv_dr_flow.3.md
  mlx5dv_dump.3.md
  mlx5dv_flow_action_esp.3.md
  mlx5dv_get_clock_info.3
  mlx5dv_get_vfio_device_list.3.md
  mlx5dv_init_obj.3
  mlx5dv_is_supported.3.md
  mlx5dv_map_ah_to_qp.3.md
  mlx5dv_mkey_check.3.md
  mlx5dv_modify_qp_lag_port.3.md
  mlx5dv_modify_qp_sched_elem.3.md
  mlx5dv_modify_qp_udp_sport.3.md
  mlx5dv_open_device.3.md
  mlx5dv_pp_alloc.3.md
  mlx5dv_qp_cancel_posted_send_wrs.3.md
  mlx5dv_query_device.3
  mlx5dv_query_port.3.md
  mlx5dv_query_qp_lag_port.3.md
  mlx5dv_reserved_qpn_alloc.3.md
  mlx5dv_sched_node_create.3.md
  mlx5dv_ts_to_ns.3
  mlx5dv_wr_mkey_configure.3.md
  mlx5dv_vfio_get_events_fd.3.md
  mlx5dv_vfio_process_events.3.md
  mlx5dv_wr_post.3.md
  mlx5dv_wr_set_mkey_crypto.3.md
  mlx5dv_wr_set_mkey_sig_block.3.md
  mlx5dv.7
)
rdma_alias_man_pages(
 mlx5dv_alloc_var.3 mlx5dv_free_var.3
 mlx5dv_create_mkey.3 mlx5dv_destroy_mkey.3
 mlx5dv_create_steering_anchor.3 mlx5dv_destroy_steering_anchor.3
 mlx5dv_crypto_login.3 mlx5dv_crypto_login_query_state.3
 mlx5dv_crypto_login.3 mlx5dv_crypto_logout.3
 mlx5dv_crypto_login_create.3 mlx5dv_crypto_login_destroy.3
 mlx5dv_crypto_login_create.3 mlx5dv_crypto_login_query.3
 mlx5dv_dek_create.3 mlx5dv_dek_query.3
 mlx5dv_dek_create.3 mlx5dv_dek_destroy.3
 mlx5dv_devx_alloc_msi_vector.3 mlx5dv_devx_free_msi_vector.3
 mlx5dv_devx_alloc_uar.3 mlx5dv_devx_free_uar.3
 mlx5dv_devx_create_cmd_comp.3 mlx5dv_devx_destroy_cmd_comp.3
 mlx5dv_devx_create_eq.3 mlx5dv_devx_destroy_eq.3
 mlx5dv_devx_create_event_channel.3 mlx5dv_devx_destroy_event_channel.3
 mlx5dv_devx_create_cmd_comp.3 mlx5dv_devx_get_async_cmd_comp.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_general_cmd.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_destroy.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_query.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_query_async.3
 mlx5dv_devx_obj_create.3 mlx5dv_devx_obj_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_qp_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_cq_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_cq_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_wq_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_wq_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_srq_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_srq_query.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_ind_tbl_modify.3
 mlx5dv_devx_qp_modify.3 mlx5dv_devx_ind_tbl_query.3
 mlx5dv_devx_subscribe_devx_event.3 mlx5dv_devx_subscribe_devx_event_fd.3
 mlx5dv_devx_umem_reg.3 mlx5dv_devx_umem_dereg.3
 mlx5dv_devx_umem_reg.3 mlx5dv_devx_umem_reg_ex.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_aso.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_table.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_root_table.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_ib_port.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_ibv_qp.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_devx_tir.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_vport.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_dest_array.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_flow_counter.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_drop.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_default_miss.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_flow_sampler.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_flow_meter.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_modify_header.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_packet_reformat.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_pop_vlan.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_push_vlan.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_create_tag.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_modify_aso.3
 mlx5dv_dr_flow.3 mlx5dv_dr_action_modify_flow_meter.3
 mlx5dv_dr_flow.3 mlx5dv_dr_aso_other_domain_link.3
 mlx5dv_dr_flow.3 mlx5dv_dr_aso_other_domain_unlink.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_allow_duplicate_rules.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_sync.3
 mlx5dv_dr_flow.3 mlx5dv_dr_domain_set_reclaim_device_memory.3
 mlx5dv_dr_flow.3 mlx5dv_dr_matcher_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_matcher_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_matcher_set_layout.3
 mlx5dv_dr_flow.3 mlx5dv_dr_rule_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_rule_destroy.3
 mlx5dv_dr_flow.3 mlx5dv_dr_table_create.3
 mlx5dv_dr_flow.3 mlx5dv_dr_table_destroy.3
 mlx5dv_dump.3 mlx5dv_dump_dr_domain.3
 mlx5dv_dump.3 mlx5dv_dump_dr_matcher.3
 mlx5dv_dump.3 mlx5dv_dump_dr_rule.3
 mlx5dv_dump.3 mlx5dv_dump_dr_table.3
 mlx5dv_pp_alloc.3 mlx5dv_pp_free.3
 mlx5dv_reserved_qpn_alloc.3 mlx5dv_reserved_qpn_dealloc.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_create.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_destroy.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_leaf_modify.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_node_destroy.3
 mlx5dv_sched_node_create.3 mlx5dv_sched_node_modify.3
 mlx5dv_wr_mkey_configure.3 mlx5dv_wr_set_mkey_access_flags.3
 mlx5dv_wr_mkey_configure.3 mlx5dv_wr_set_mkey_layout_interleaved.3
 mlx5dv_wr_mkey_configure.3 mlx5dv_wr_set_mkey_layout_list.3
 mlx5dv_wr_post.3 mlx5dv_wr_set_dc_addr.3
 mlx5dv_wr_post.3 mlx5dv_wr_set_dc_addr_stream.3
 mlx5dv_wr_post.3 mlx5dv_qp_ex_from_ibv_qp_ex.3
 mlx5dv_wr_post.3 mlx5dv_wr_memcpy.3
 mlx5dv_wr_post.3 mlx5dv_wr_mr_interleaved.3
 mlx5dv_wr_post.3 mlx5dv_wr_mr_list.3
 mlx5dv_wr_post.3 mlx5dv_wr_raw_wqe.3
)

=== pyverbs/providers/mlx5/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file

rdma_cython_module(pyverbs/providers/mlx5 mlx5
  dr_action.pyx
  dr_domain.pyx
  dr_matcher.pyx
  dr_rule.pyx
  dr_table.pyx
  libmlx5.pyx
  mlx5_enums.pyx
  mlx5_vfio.pyx
  mlx5dv.pyx
  mlx5dv_crypto.pyx
  mlx5dv_flow.pyx
  mlx5dv_mkey.pyx
  mlx5dv_objects.pyx
  mlx5dv_sched.pyx
)

=== debian/changelog ===
rdma-core (50.0-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:21:10 +0000

rdma-core (50.0-2build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:15:09 +0100

rdma-core (50.0-2) unstable; urgency=medium

  * Rename libraries for 64-bit time_t transition (Closes: #1064313)

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 29 Feb 2024 03:11:46 +0100

rdma-core (50.0-1) unstable; urgency=medium

  * New upstream release.
    - support cython 3.0.x (Closes: #1056882)
    - add support for loongarch64 (Closes: #1059022)
  * Replace obsolete pkg-config by pkgconf
  * Update years in debian/copyright
  * Use unversioned library names in package description
  * Installs udev/systemd files below /usr/lib (Closes: #1059188)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 26 Feb 2024 17:41:04 +0100

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
                cython3,
                debhelper-compat (= 13),
                dh-python,
-               dpkg-dev (>= 1.17),
+               dpkg-dev (>= 1.22.5),
                libnl-3-dev,
                libnl-route-3-dev,
                libsystemd-dev,
                libudev-dev,
                ninja-build,
                pandoc,
-               pkg-config,
+               pkgconf,
                python3-dev,
                python3-docutils,
                valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x]
@@ -191,7 +191,7 @@
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
-Depends: libibverbs-dev, librdmacm1 (= ${binary:Version}), ${misc:Depends}
+Depends: libibverbs-dev, librdmacm1t64 (= ${binary:Version}), ${misc:Depends}
 Description: Development files for the librdmacm library
  librdmacm is a library that allows applications to set up reliable
  connected and unreliable datagram transfers when using RDMA adapters.
@@ -206,11 +206,14 @@
  provided by libibverbs, which provides the interface used to actually
  transfer data.
  .
- This package is needed to compile programs against librdmacm1.
+ This package is needed to compile programs against librdmacm.
  It contains the header files and static libraries (optionally)
  needed for compiling.
 
-Package: librdmacm1
+Package: librdmacm1t64
+Provides: ${t64:Provides}
+Replaces: librdmacm1
+Breaks: librdmacm1 (<< ${source:Version})
 Architecture: linux-any
 Multi-Arch: same
 Section: libs
@@ -249,7 +252,7 @@
  provided by libibverbs, which provides the interface used to actually
  transfer data.
  .
- This package contains useful librdmacm1 example programs such as
+ This package contains useful librdmacm example programs such as
  rping and udaddy.
 
 Package: srptools
@@ -280,9 +283,7 @@
 
 Package: infiniband-diags
 Architecture: linux-any
-Depends: libibnetdisc5 (= ${binary:Version}),
+Depends: libibnetdisc5t64 (= ${binary:Version}),
          ${misc:Depends},
          ${perl:Depends},
          ${shlibs:Depends}
-Description: InfiniBand diagnostic programs
- InfiniBand is a switched fabric communications link used in

=== debian/rules ===
--- 
+++ 
@@ -29,12 +29,12 @@
 		     "-DDISTRO_FLAVOUR=Debian" \
 		     "-DCMAKE_BUILD_TYPE=Release" \
 		     "-DCMAKE_INSTALL_SYSCONFDIR:PATH=/etc" \
-		     "-DCMAKE_INSTALL_SYSTEMD_SERVICEDIR:PATH=/lib/systemd/system" \
+		     "-DCMAKE_INSTALL_SYSTEMD_SERVICEDIR:PATH=/usr/lib/systemd/system" \
 		     "-DCMAKE_INSTALL_INITDDIR:PATH=/etc/init.d" \
 		     "-DCMAKE_INSTALL_LIBEXECDIR:PATH=/usr/lib" \
 		     "-DCMAKE_INSTALL_SHAREDSTATEDIR:PATH=/var/lib" \
 		     "-DCMAKE_INSTALL_RUNDIR:PATH=/run" \
-		     "-DCMAKE_INSTALL_UDEV_RULESDIR:PATH=/lib/udev/rules.d" \
+		     "-DCMAKE_INSTALL_UDEV_RULESDIR:PATH=/usr/lib/udev/rules.d" \
 		     "-DCMAKE_INSTALL_PERLDIR:PATH=/usr/share/perl5" \
 		     "-DENABLE_STATIC=1" \
 		     $(EXTRA_CMAKE_FLAGS)
